#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include"SimpleImage.h"
#include"ppmio.h"
#include"pgmio.h"
#include"ColorImage.h"
#include"otsu.h"

Image* getMask(char *filename){
  Image *tmp = new Image();
  getPGM(tmp,filename);
  /* preprocessing */
  
   int HISTSIZE=256;
  Otsu *myotsu = new Otsu(HISTSIZE);

  double threshold = ((double)(myotsu->find_otsu_threshold(tmp)));
  int i,j;
  for(i=0;i<tmp->sy;i++)
    for(j=0;j<tmp->sx;j++){
      if(tmp->img[i][j]>=threshold){
	tmp->img[i][j] = 255.0;
      }else{
	tmp->img[i][j] = 0.0;
      }
    }
      delete myotsu;

  /* end preprocessing */
  return tmp;
}


int main(int argc,char *argv[]){
  
  ColorImage* Source = new ColorImage(argv[1]);
  Image *Mask = getMask(argv[2]);
  
  
  
  
  ColorImage* Target = new ColorImage(argv[3]);

  if(!(Source->sx==Mask->sx&&Mask->sx==Target->sx&&
      Source->sy==Mask->sy&&Mask->sy==Target->sy)){
  
    printf("All image size should be same !\n");
    delete Source;
    delete Target;
    delete Mask;
    return 0;
  
  }
  
  
  
  double Alpha = atof(argv[5]);if(!(Alpha>=0.0&&Alpha<=1.0)){
     printf("Alpha should be between 0 to 1.0\n");
    delete Source;
    delete Target;
    delete Mask;
    return 0;
  
  }
  int i,j;
  ColorImage *out = new ColorImage(Target->sx,Target->sy);
  for(i=0;i<Target->sy;i++)
    for(j=0;j<Target->sx;j++){
      if(Mask->img[i][j]==255.0){
	out->R->img[i][j] = Alpha*Source->R->img[i][j]+(1.0-Alpha)*Target->R->img[i][j];
	out->G->img[i][j] = Alpha*Source->G->img[i][j]+(1.0-Alpha)*Target->G->img[i][j];
	out->B->img[i][j] = Alpha*Source->B->img[i][j]+(1.0-Alpha)*Target->B->img[i][j];
      }else{
	out->R->img[i][j] = Target->R->img[i][j];
	out->G->img[i][j] = Target->G->img[i][j];
	out->B->img[i][j] = Target->B->img[i][j];
      
      }
    }
 
  
  
 



  out->saveColorImagePPM(argv[4]);
  
  
    
  delete Source;
  delete Target;
  delete Mask;
  delete out;

  return 0;
}


